#######################################################################
# Copyright (C) 2015 Jokanji
# 2015.09-11 Jokanji(m.ma)
# bnank̍(ϐ)郂W[  
#######################################################################
# Set_Var_Obj.pm (Ver 1.0)
#  Jokanji
#201x.xx.xx ...
#######################################################################
#-O
package Set_Var_Obj;
#######################################################################
require Exporter;
@ISA = ("Exporter");
@EXPORT = qw(Set_var_obj Unset_var_obj); 

use strict;

my %Hovar=();
#######################################################################
sub Set_var_obj
{
  my ($name) = @_; #(ϐ)

  if (!(exists $main::Hdd{$name})){ print STDERR "Set_Var_Obj::Set_var_obj ERR! $name Hdd ܂\n"; exit; }
  my $data=$main::Hdd{$name};

  my $obj=&cob_obj_set($name,$data);
}
#######################################################################
sub Unset_var_obj
{
  my ($name) = @_; #(ϐ)

  if (!(exists $main::Hdd{$name})){ print STDERR "Set_Var_Obj::Unset_var_obj ERR! $name Hdd ܂\n"; exit; }
  my $data=$main::Hdd{$name};
  my ($lev,$pic,$redf,$ocurs,$oya,$ocurs_set,$offs,$keta,$kes)=split /\|/,$data;
  if ($ocurs_set eq "0"){
    {
      no strict 'refs';
      my $nm="main::".$name;
      my $obj = tied $$nm;
      untie $$nm;
      return $obj;
    }
  }else{
    print STDERR "Set_Var_Obj::Unset_var_obj ER zUnset(untie)ł܂IB\n";
  }
}
#######################################################################
sub set_type
{
  my ($pic)=@_;

  my $type=0;
  if    ($pic =~ /x/ || $pic =~ /S/){ $type=10; }   
  elsif ($pic =~ /z|\+|\-|\\|\,|b|\//){ $type=90; }
  elsif ($pic =~ /9/ && $pic =~ /v/){
    my $s0=substr($pic,0,1);
    if ($s0 eq "s"){ $type=31; }else{ $type=30; }
  }
  elsif ($pic =~ /9/ && $pic !~ /v/){
    my $s0=substr($pic,0,1);
    if ($s0 eq "s"){ $type=21; }else{ $type=20; }
  }
  return $type;
}
#######################################################################
sub cob_obj_set
{ 
  my ($name,$data)=@_;

  my ($lev,$pic,$redf,$ocurs,$oya,$ocurs_set,$offs,$keta,$kes)=split /\|/,$data;

  my $oya01="";
  if ($ocurs_set eq "0"){
    my $off=&oya01_offset_calc($name,\$oya01,"");
    &tie_scalar($name,$data,$oya01,$off); 
  }else{
    my $ocx=""; my $mx=0; my $wi=0;
    &occurs_calc(2,$ocurs_set,\$ocx,\$mx,\$wi); #//mx߂
    for (my $j=0;$j<$mx;$j++){
      $ocx=""; $wi=$j;
      &occurs_calc(2,$ocurs_set,\$ocx,\$wi,\$j); #//ocx߂
      my $off=&oya01_offset_calc($name,\$oya01,$ocx);
      &tie_array($name,$data,$oya01,$off,$ocx);
    }
  }
}
#######################################################################
# XJ[Ȃ tie ֐Kp
sub tie_scalar
{
  my ($name,$data,$oya01,$off)=@_;

  my $obj=[$name,"",0,0,"",0,0,0,"",""]; #pointer

  $Hovar{$name}=$obj; #-
  $main::Hval{$name}=$obj; #-

  my ($lev,$pic,$redf,$ocurs,$oya,$ocurs_set,$offs,$keta,$kes)=split /\|/,$data;

  $obj->[1]=$oya01;
  if ($name ne $oya01){
    if (!(exists $Hovar{$oya01})){ print STDERR "Set_Var_Obj::tie_scalar ERR! $oya01 Hovar ܂\n"; exit; }
  } 
  $obj->[2]=$Hovar{$oya01};
  my $typ=&set_type($pic);
  $obj->[3]=$typ;
  $obj->[4]=$pic;
  $obj->[5]=$keta;
  $obj->[6]=$kes;
  $obj->[7]=$off;
  $obj->[8]="0";
  my $val="";
  if ($typ >=20 && $typ <=31){ $val='0' x  $keta; }
  else                       { $val=' ' x  $keta; }
  $obj->[9]=$val;

  {
    no strict 'refs';
    my $nm="main::".$name;
    tie $$nm,'Tie_Scalar',$obj;
  }
} 
#######################################################################
# zȂ΁Az̗vf(XJ[) tie ֐Kp
sub tie_array
{
  my ($name,$data,$oya01,$off,$ocx)=@_;

  my $obj=[$name,"",0,0,"",0,0,0,"",""]; #pointer

  $Hovar{$name}=$obj; #-
  my $namc=$name.'='.$ocx;
  $main::Hval{$namc}=$obj; #-
  my ($lev,$pic,$redf,$ocurs,$oya,$ocurs_set,$offs,$keta,$kes)=split /\|/,$data;

  $obj->[1]=$oya01;
  if ($name ne $oya01){
    if (!(exists $Hovar{$oya01})){ print STDERR "Set_Var_Obj::tie_array ERR! $oya01 Hovar ܂\n"; exit; }
  } 
  $obj->[2]=$Hovar{$oya01};
  my $typ=&set_type($pic);
  $obj->[3]=$typ;
  $obj->[4]=$pic;
  $obj->[5]=$keta;
  $obj->[6]=$kes;
  $obj->[7]=$off;
  $obj->[8]=$ocx;
  my $val="";
  if ($typ >=20 && $typ <=31){ $val='0' x  $keta; }
  else                       { $val=' ' x  $keta; }
  $obj->[9]=$val;

  my $bracket='['.$ocx.']';
  if ($ocx =~ /:/){
    $bracket =~ s/:/\]\[/g;
  }

  my $ss='&tie_array_set(\$main::' . $name . $bracket . ', $obj);';
  eval $ss;
  if ($@){ print "EVAL $@ \n"; }
 }
#######################################################################
sub tie_array_set #z̃^Cϐ
{ 
  my ($r_var,$obj)=@_;

  tie $$r_var,'Tie_Scalar',$obj;
}
#######################################################################
sub oya01_offset_calc
{ 
  my ($inp,$r_oya,$occ)=@_;
   
  my $Occ=$occ; my $Self=$inp; my $sum=0;
   
  while (1) 
  {
    my $data=$main::Hdd{$Self};  
    if ($data eq ""){ print STDERR "ERR! $Self Hdd ܂\n"; exit; }
    my ($lev,$pic,$redf,$ocurs,$oya,$ocurs_set,$offs,$keta,$kes)=split /\|/,$data;
    my $self_Oya=$oya; my $self_Ocurs_set=$ocurs_set; my $self_Offs=$offs; my $self_Keta=$keta;

    if ($self_Oya eq "*"){ $$r_oya=$Self; last; }

    my $data=$main::Hdd{$self_Oya};  
    if ($data eq ""){ print STDERR "ERR! $self_Oya Hdd ܂\n"; exit; }
    my ($lev,$pic,$redf,$ocurs,$oya,$ocurs_set,$offs,$keta,$kes)=split /\|/,$data;
    if ($self_Ocurs_set eq "0"){ #//ȔzłȂ
      $sum+=$self_Offs;
      $Occ="";
    }else{                       #//Ȕz
      if ($self_Ocurs_set eq $ocurs_set){ #
        $sum+=$self_Offs;
      }else{
        my $oco=""; my $ci=0;
        if ($Occ !~ /:/){ $oco=$Occ; }
        else{
          my @spw=split /\:/,$Occ; $ci=$#spw; $oco=$spw[$ci]; #
        }
        $sum += $self_Offs + $self_Keta*($oco+0); #
        if ($ocurs_set ne "0"){ #//ezŁAȂ̔z񃌃xƈႤ
            my @spc=split /\:/,$Occ;
            my $ix=$#spc; my $occz="";
            for (my $i=0;$i<$ix;$i++){
               if ($occz eq ""){ $occz=$spc[$i]; }
               else            { $occz=$occz.":".$spc[$i]; }
            }
            $Occ=$occz;
        }else{                 #//ezłȂ
            $Occ="";
        }
      }
    }
    $Self=$self_Oya; #//e->
  }#//---while 
  return $sum;
}
#######################################################################
sub occurs_calc
{
  my ($kb,$ocx,$ocy,$mx,$ni2)=@_;

  my $ni=$$ni2;
  if ($kb==1) 
  {
    my @ix=(0,0,0,0,0,0,0,); my $i=0;
    if($ocx =~ /:/){
      my @sp=split /\:/,$ocx; my $mul=1;
      for (my $n=0;$n<=$#sp;$n++){
        $ix[$i]=$sp[$n]; $mul=$mul * $ix[$i]; $i++;
      }
      $$mx=$mul;
    }else{
      $$mx=$ix[$i++]=$ocx;
    }
    my @iy=(0,0,0,0,0,0,0,); my $j=0;
    if($$ocy =~ /:/){
      my @sp=split /\:/,$$ocy;
      ##foreach my $s (@sp){ $iy[$j++]=$s; }
      for (my $n=0;$n<=$#sp;$n++){ $iy[$j++]=$sp[$n]; }
    }else{
      $iy[$j++]=$$ocy;
    }
    if ($i != $j){ print "occurs_calc ERR! z񃌃xH $ocx $$ocy\n"; exit; }
    for (my $k=0;$k<$j;$k++){
      my $mul=1;
      for (my $n=$k+1;$n<$j;$n++){
         $mul=$mul * $ix[$n];
      }
      $ni += $iy[$k] * $mul;
    }
    $$ni2=$ni;
  }
  if ($kb==2) 
  {
    my @ix=(0,0,0,0,0,0,0,); my $i=0;
    if($ocx =~ /:/){
      my @sp=split /\:/,$ocx; my $mul=1;
      for (my $n=0;$n<=$#sp;$n++){
        $ix[$i]=$sp[$n]; $mul=$mul * $ix[$i]; $i++;
      }
      $$mx=$mul;
    }else{
      $$mx=$ix[$i++]=$ocx;
    }
    my @iy=(0,0,0,0,0,0,0,); my $rest=$ni;
    for (my $k=0;$k<$i;$k++){
      my $mul=1;
      for (my $n=$k+1;$n<$i;$n++){
        $mul=$mul * $ix[$n];
      }
      if ($ni >=$mul){
        my $iw= int($ni / $mul); $iy[$k]=$iw; $ni=$ni-($iw*$mul);
      }
    }
    $$ocy="";
    for (my $k=0;$k<$i;$k++){
      if ($k==0){ $$ocy="$iy[$k]"; }
      else      { $$ocy.=":".$iy[$k]; }
    }
  }
}
#######################################################################
my ($Gfsec1,$Gfmin1,$Gfhour1);
#
INIT
{
  ($Gfsec1,$Gfmin1,$Gfhour1)=(localtime)[0,1,2];
}
#######################################################################
#I
END
{
  my ($Gfsec2,$Gfmin2,$Gfhour2)=(localtime)[0,1,2];
  print "$Gfhour1:$Gfmin1:$Gfsec1\n";
  print "$Gfhour2:$Gfmin2:$Gfsec2\n"; 
}
#######################################################################
#---------------------------------------------------------------------#
#^CϐNX(pbP[W)
#-O
package Tie_Scalar;
use Val_Edit;
#######################################################################
sub TIESCALAR
{
  my ($class,$obj) = @_;
  return bless($obj,$class);
}
#######################################################################
sub FETCH 
{
  my ($obj)=@_;

  my ($val);
  if ($obj->[0] eq $obj->[1]){ $val=$obj->[9]; } #ŏʂ̐e
  else{
    if ($obj->[2]->[9] eq ""){
      $obj->[2]->[9] = ' ' x $obj->[2]->[5];
    }
    $val = substr($obj->[2]->[9],$obj->[7],$obj->[5]);
  }
  if ($obj->[3] >=20 && $obj->[3] <=31 && $val =~ /^[ ]+$/){
    $val='0' x $obj->[5]; substr($obj->[2]->[9],$obj->[7],$obj->[5]) = $val;
  } 
  return $val;
}
#######################################################################
sub STORE 
{
  my ($obj,$val)=@_;

  $obj->[9] = &Val_Edit::Edit($val,$obj->[3],$obj);

  if ($obj->[0] ne $obj->[1]){
    if ($obj->[2]->[9] eq ""){
      $obj->[2]->[9] = ' ' x $obj->[2]->[5];
    }
    substr($obj->[2]->[9],$obj->[7],$obj->[5]) = $obj->[9];
  }
}
#######################################################################
1;
