#######################################################################
# Copyright (C) 2015 Jokanji
# 2015.09-11 Jokanji(m.ma)
# ohbҏW̃pbP[W(W[)  
#######################################################################
# Val_Edit.pm (Ver 1.0)
#  Jokanji
#201x.xx.xx ...
#######################################################################
#-O
package Val_Edit;  
#######################################################################
require Exporter;
@ISA = ("Exporter");
@EXPORT = qw(Edit); 

use POSIX qw(floor ceil);
use Math::Round;

use strict;

#######################################################################
sub Edit
{
  my ($val,$typ,$obj)=@_;
  
  my $pic=$obj->[4]; my $ket=$obj->[5]; my $kes=$obj->[6];

  if ($typ >=20 && $typ <=21) #
  {  
    if ($main::Big_Num==1){
      $val=&Edit_Num1b($val,$ket,$typ,$obj);
    }else{   
      $val=&Edit_Num1($val,$ket,$typ,$obj);
    }
  }
  elsif ($typ >=30 && $typ <=31) #ȉ܂ސ
  {  
    if ($main::Big_Num==1){
      $val=&Edit_Num2b($val,$ket,$kes,$typ,$obj);
    }else{
      $val=&Edit_Num2($val,$ket,$kes,$typ,$obj);
    }
  }
  elsif ($typ==10) #p
  {  
    my ($ln,$pad);
    $ln=length($val);        
    if    ($ln > $ket){        
      $val=substr($val,0,$ket);                 
    }
    elsif ($ln < $ket){         
      $pad=' ' x ($ket - $ln);  
      $val=$val.$pad;            
    }
  }
  else{
    print STDERR "Val_Edit::Edit ERR! $typ ??? EXIT!\n"; exit;
  }

  return $val;
}
#######################################################################
# 
sub Edit_Num1
{
  my ($val,$ket,$typ,$obj)=@_;

  my $wval=$val;
  if ($main::_RD==1){ #ľܓ 
    $wval=round($wval);
    $main::_RD=0;
  }else{
    if ($wval >0){
      $wval=floor($wval);
    }else{
      $wval=ceil($wval);
    }
  }

  $wval=sprintf("%.*f",0,$wval);

  $val=&Num_chk($val,$wval,$ket,$typ,$obj);

  return $val;
}
#######################################################################
# ȉ܂ސ
sub Edit_Num2
{
  my ($val,$ket,$kes,$typ,$obj)=@_;

  my $wval=$val;
  if ($main::_RD==1){ #ľܓ 
    my $pow=10**$kes;
    $wval=round($wval*$pow)/$pow;
    $main::_RD=0;
  }else{              #-؂̂
    my $pow=10**$kes;
    if ($wval >0){
      $wval=floor($wval*$pow)/$pow;
    }else{
      $wval=ceil($wval*$pow)/$pow;
    }
  }
  $wval=sprintf("%.*f",$kes,$wval);

  $val=&Num_chk($val,$wval,$ket,$typ,$obj);

  return $val;
}
#######################################################################
sub Num_chk
{
  my ($val,$wval,$ket,$typ,$obj)=@_;

  my $ln=0; my $ss=""; my $sz_er=0;
  if ($typ==21 || $typ==31) #-TCt
  {
    if ($val <0){ #-
      $wval =~ s/\-//; $ln=length($wval);
      if ($ln==($ket-1)){
        $ss="-".$wval;
      }elsif ($ln < ($ket-1)){
        my $wzero='0' x (($ket-1)-$ln);
        $ss="-".$wzero.$wval;
      }elsif ($ln > ($ket-1)){ $sz_er=1;
        ##print "ӂHĉI\n"; 
        $wval=substr($wval,$ln-($ket-1),$ket-1);
        $ss="-".$wval;
      }
    }else{
      if ($wval =~ /\+/){ $wval =~ s/\+//; }
      $ln=length($wval);
      if ($ln==($ket-1)){
        $ss="+".$wval;
      }elsif ($ln < ($ket-1)){
        my $wzero='0' x (($ket-1)-$ln);
        $ss="+".$wzero.$wval;
      }elsif ($ln > ($ket-1)){ $sz_er=1;
        ##print "ӂHĉI\n"; 
        $wval=substr($wval,$ln-($ket-1),$ket-1);
        $ss="+".$wval;
      }
    }
  }
  elsif ($typ==20 || $typ==30) #-TCȂ
  {  
    if ($wval =~ /\-/){ $wval =~ s/\-//; }
    if ($wval =~ /\+/){ $wval =~ s/\+//; }
    $ln=length($wval);
    if ($ln==$ket){
      $ss=$wval;
    }elsif ($ln < $ket){
      my $wzero='0' x ($ket-$ln);
      $ss=$wzero.$wval;
    }elsif ($ln > $ket){ $sz_er=1;
      ##print "ӂHĉI\n"; 
      $ss=substr($wval,$ln-$ket,$ket);
    }
  }
  $val=$ss;

  $main::_SZ_ERR=0;
  if ($sz_er >0){
    $val=&Size_Error($ket,$val,$obj);
  }

  return $val;
} 
#######################################################################
sub Size_Error
{
  my ($ket,$val,$obj)=@_;

  if ($main::_SC==1) #//SIZE ERROR(ӂ)w
  {
    my $val_b="";
    if ($obj->[0] eq $obj->[1]){ $val_b=$obj->[9]; }
    else{
      $val_b=substr($obj->[2]->[9],$obj->[7],$obj->[5]);
    }
    if ($val_b eq ""){
      $val_b='0' x $ket;
      print "size_errorӂłAlȂ̂Ń[Ƃ܂\n";
    }
    $main::_SZ_ERR=1;
    return $val_b;
  }else{
    $main::_SZ_ERR=0;
    return $val;
  }
}
#######################################################################
# 
sub Edit_Num1b
{
use bignum;
  my ($val,$ket,$typ,$obj)=@_;

  if ($val eq ""){ return 0; } #-??????

  my ($upp,$below);
  if ($val =~ /\./){ ($upp,$below)=split /\./,$val; }
  else             { $upp=$val; $below=""; }
  my $sgn=substr($upp,0,1); my $keta=$ket;
  if ($typ==20){ #-TCȂ(+)
    if ($sgn eq '+' || $sgn eq '-'){ substr($upp,0,1)='0'; }
  }
  elsif ($typ==21){ #-TC萮(+,-)
    if ($sgn eq '+' || $sgn eq '-'){ $upp=substr($upp,1,length($upp)-1); }
    else                           { $sgn='+'; }         
    $keta--;
  }

  my $rd=0;
  if ($main::_RD==1){ $main::_RD=0; #ľܓ 
    my $b0=0;
    if ($below ne ""){ $b0=substr($below,0,1); }
    if ($b0 >=5){ $rd=1; }
  }else{ #-؎̂
      
  }
  $upp+=$rd;

  my $ln=length($upp); my $sz_er=0;
  if ($ln==$keta){

  }elsif ($ln < $keta){
    my $wzero='0' x ($keta-$ln);
    $upp=$wzero.$upp;
  }elsif ($ln > $keta){ $sz_er=1; ##print "ӂHĉI\n"; 
    $upp=substr($upp,$ln-$keta,$keta);
  }
  if ($typ==20){
    
  }
  elsif ($typ==21){
    $upp=$sgn.$upp;
  }

  $main::_SZ_ERR=0;
  if ($sz_er >0){
    $upp=&Size_Error($ket,$upp,$obj);
  }
  return $upp;
}
#######################################################################
# ȉ܂ސ
sub Edit_Num2b
{
use bignum;
  my ($val,$ket,$kes,$typ,$obj)=@_;

  if ($val eq ""){ return 0; } #-??????

  my ($upp,$below);
  if ($val =~ /\./){ ($upp,$below)=split /\./,$val; }
  else             { $upp=$val; $below=""; }
  my $sgn=substr($upp,0,1); my $keta=$ket-$kes-1;
  if ($typ==30){ #-TCȂ(+)
    if ($sgn eq '+' || $sgn eq '-'){ substr($upp,0,1)='0'; }
  }
  elsif ($typ==31){ #-TC萮(+,-)
    if ($sgn eq '+' || $sgn eq '-'){ $upp=substr($upp,1,length($upp)-1); }
    else                           { $sgn='+'; }         
    $keta--;
  }
  my $rd=0;
  if ($main::_RD==1){ $main::_RD=0; #ľܓ 
    my $b0=0;
    if (length($below) > $kes){ $b0=substr($below,$kes,1); }
    if ($b0 >=5){ $rd=1/(10**$kes); }
  }
  $below=substr($below,0,$kes);
  $below=$below/(10**$kes)+$rd;
  if ($below==1.0){ $rd=1; $below=0; }
  else            { $rd=0; }
  $below=sprintf("%.*f",$kes,$below);
  $below =~ s/0\.//g;

  $upp+=$rd;

  my $ln=length($upp); my $sz_er=0;
  if ($ln==$keta){

  }elsif ($ln < $keta){
    my $wzero='0' x ($keta-$ln);
    $upp=$wzero.$upp;
  }elsif ($ln > $keta){ $sz_er=1; ##print "ӂHĉI\n"; 
    $upp=substr($upp,$ln-$keta,$keta); ##print "ӂH upp=$upp\n";
  }
  if ($typ==30){
    $val=$upp.'.'.$below;
  }
  elsif ($typ==31){
    $val=$sgn.$upp.'.'.$below;
  }

  $main::_SZ_ERR=0;
  if ($sz_er >0){
    $val=&Size_Error($ket,$val,$obj);
  }
  return $val;
}
###################################################
1;
