000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. PERF01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000 WORKING-STORAGE SECTION.
000000 01  WORK.
000000     02 CNT   PIC 9(5). 
000000     02 SUM01 PIC 9(7). 
000000     02 CNT01 PIC 9(5).
000000     02 CNT02 PIC 9(5).
000000     02 SEISEKI PIC X.
000000     02 KAZOKU PIC 9(2).
000000     02 NENREI  PIC 99.
000000     02 SALARY  PIC 9(7) VALUE 300000.
000000     02 AGE  PIC 9(3).  
000000     02 TEST-ALL PIC X(18).
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START PERF01" .
000000     MOVE ALL "PERF01" TO TEST-ALL.
000000     DISPLAY "TEST-ALL=" TEST-ALL.
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-PERF-RTN THRU 01-PERF-RTN-END. 
000000     PERFORM 02-PERF-RTN THRU 02-PERF-RTN-END. 
000000     PERFORM 03-PERF-RTN THRU 03-PERF-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END PERF01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-PERF-RTN RAS TEST BEFORE,AFTER
000000******************************************************
000000 01-PERF-RTN.
000000     MOVE ZERO TO CNT SUM01.
000000     PERFORM UNTIL CNT >= 10
000000       ADD 1 TO CNT ;
000000       COMPUTE SUM01 = SUM01 + CNT ;
000000     END-PERFORM.
000000     DISPLAY "A SUM01=" SUM01.
000000*    ***
000000     MOVE ZERO TO CNT SUM01.
000000     PERFORM TEST AFTER UNTIL CNT >= 10
000000       ADD 1 TO CNT ;
000000       COMPUTE SUM01 = SUM01 + CNT ;
000000     END-PERFORM.
000000     DISPLAY "B SUM01=" SUM01.
000000*    ***
000000     MOVE ZERO TO SUM01.
000000     PERFORM VARYING CNT FROM 1 BY 1 UNTIL CNT > 10
000000       COMPUTE SUM01 = SUM01 + CNT ;
000000     END-PERFORM.
000000     DISPLAY "C SUM01=" SUM01.
000000*    ***
000000     MOVE ZERO TO SUM01.
000000     PERFORM TEST AFTER
000000             VARYING CNT FROM 1 BY 1 UNTIL CNT > 10
000000       COMPUTE SUM01 = SUM01 + CNT ;
000000     END-PERFORM.
000000     DISPLAY "D SUM01=" SUM01.
000000*    ***
000000     MOVE ZERO TO SUM01.
000000     PERFORM TEST AFTER VARYING CNT FROM 1 BY 1 UNTIL CNT >= 10
000000       COMPUTE SUM01 = SUM01 + CNT ;
000000     END-PERFORM.
000000     DISPLAY "E SUM01=" SUM01.
000000*    ***
000000     MOVE ZERO TO SUM01.
000000     PERFORM VARYING CNT01 FROM 1 BY 1 UNTIL CNT01 > 6
000000       PERFORM VARYING CNT02 FROM 1 BY 1 UNTIL CNT02 > 6
000000         COMPUTE SUM01 = SUM01 + CNT01 + CNT02 ;
000000       END-PERFORM  
000000     END-PERFORM.
000000     DISPLAY "F SUM01=" SUM01 " CNT01=" CNT01 " CNT02=" CNT02.
000000*    ***
000000     MOVE ZERO TO SUM01.
000000     PERFORM TEST AFTER VARYING CNT01 FROM 1 BY 1 UNTIL CNT01 > 6
000000       PERFORM TEST AFTER 
000000               VARYING CNT02 FROM 1 BY 1 UNTIL CNT02 > 6
000000         COMPUTE SUM01 = SUM01 + CNT01 + CNT02 ;
000000       END-PERFORM  
000000     END-PERFORM.
000000     DISPLAY "G SUM01=" SUM01 " CNT01=" CNT01 " CNT02=" CNT02.
000000 01-PERF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-PERF-RTN RAS@(O)PERFORM
000000******************************************************
000000 02-PERF-RTN.
000000     MOVE ZERO TO SUM01.
000000     PERFORM 01-SUMRY-RTN
000000       VARYING CNT FROM 1 BY 1 UNTIL CNT > 10.
000000     DISPLAY "02-PERF (1) SUM01=" SUM01.
000000*    ***
000000     MOVE ZERO TO SUM01.
000000     PERFORM VARYING CNT01 FROM 1 BY 1 UNTIL CNT01 > 6
000000       PERFORM 02-SUMRY-RTN
000000         VARYING CNT02 FROM 1 BY 1 UNTIL CNT02 > 6
000000     END-PERFORM.
000000     DISPLAY "02-PERF (2) SUM01=" SUM01 " CNT01=" CNT01
000000             " CNT02=" CNT02.
000000 02-PERF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    03-PERF-RTN 
000000******************************************************
000000 03-PERF-RTN.
000000 03-PERF-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-SUMRY-RTN section
000000******************************************************
000000 01-SUMRY-RTN SECTION.
000000     COMPUTE SUM01 = SUM01 + CNT. 
000000 01-SUMRY-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-SUMRY-RTN section
000000******************************************************
000000 02-SUMRY-RTN SECTION.
000000     COMPUTE SUM01 = SUM01 + CNT01 + CNT02. 
000000 02-SUMRY-RTN-END.
000000     EXIT.
