000000 IDENTIFICATION DIVISION.
000000 PROGRAM-ID. SEQ01.
000000 ENVIRONMENT DIVISION.
000000 INPUT-OUTPUT SECTION.
000000 FILE-CONTROL.
000000*...̓t@C
000000     SELECT INP-FILE ASSIGN "seq01.dat"
000000      ORGANIZATION SEQUENTIAL
000000      ACCESS SEQUENTIAL        
000000      FILE STATUS INP-STS.     
000000*...o̓t@C
000000     SELECT OUT-FILE ASSIGN "seq01.dat"
000000      ORGANIZATION SEQUENTIAL
000000      ACCESS SEQUENTIAL        
000000      FILE STATUS OUT-STS.   
000000 DATA DIVISION.                                                    
000000 FILE SECTION.   
000000*...̓t@C 
000000 FD  INP-FILE                                                                    
000000     LABEL RECORD STANDARD.                         
000000*...̓R[h
000000 01  INP-REC.                  
000000     02 INP-KEY. 
000000       03 INP-KY01 PIC 9(2). 
000000       03 INP-KY02 PIC 9(4). 
000000     02 INP-CD PIC X(8).
000000     02 INP-OCCUR .
000000       03 INP-OCC PIC 9(3) OCCURS 3.
000000     02 INP-SU PIC S9(5)V99.
000000 FD  OUT-FILE                                                             
000000     LABEL RECORD STANDARD.                         
000000 01  OUT-REC.                  
000000     02 OUT-KEY. 
000000       03 OUT-KY01 PIC 9(2). 
000000       03 OUT-KY02 PIC 9(4). 
000000     02 OUT-CD PIC X(8).
000000     02 OUT-OCCUR .
000000       03 OUT-OCC PIC 9(3) OCCURS 3.
000000     02 OUT-SU PIC S9(5)V99.
000000 WORKING-STORAGE SECTION.
000000 01  STATUS-AREA.                                        
000000     02 INP-STS  PIC  X(2).                  
000000     02 OUT-STS  PIC  X(4) VALUE ALL "X".                  
000000     02 OUT-STS2  PIC  X(4) VALUE HIGH-VALUES.                  
000000     02 OUT-STS3  PIC  X(4) VALUE LOW-VALUES.                  
000000     02 077OUT-NO PIC 9(4).                             
000000 01  WORK.
000000     02 INP-CNT PIC 9(3) VALUE ZERO.
000000     02 OUT-CNT PIC 9(3) VALUE ZERO.
000000     02 END-SW  PIC 9(1).
000000     02 IX PIC 9(2).
000000 01  WORK-R.
000000     02 W-VAL01 PIC X(10) VALUE "0123456789".
000000     02 W-VAL02 PIC X(10) VALUE "AinputGHIJ".
000000     02 W-VAL03 PIC X(10) VALUE "+-*/:^=.,;".
000000 01  REDEFINES WORK-R.
000000     02 W-A OCCURS 3 INDEXED BY WAI.   
000000       03 W-B PIC X(01) OCCURS 10 INDEXED BY WBI.
000000 PROCEDURE DIVISION.
000000     PERFORM START-RTN THRU START-RTN-END. 
000000     PERFORM MAIN-RTN  THRU MAIN-RTN-END.
000000     PERFORM END-RTN   THRU END-RTN-END.
000000     STOP RUN.
000000******************************************************
000000*    START-RTN 
000000******************************************************
000000 START-RTN.
000000     DISPLAY "START SEQ01" .
000000 START-RTN-END.
000000     EXIT.
000000******************************************************
000000*    MAIN-RTN 
000000******************************************************
000000 MAIN-RTN.
000000     PERFORM 01-SEQ-RTN THRU 01-SEQ-RTN-END. 
000000     PERFORM 02-SEQ-RTN THRU 02-SEQ-RTN-END. 
000000 MAIN-RTN-END.
000000     EXIT.
000000******************************************************
000000*    END-RTN 
000000******************************************************
000000 END-RTN.
000000     DISPLAY "END SEQ01" .
000000 END-RTN-END.
000000     EXIT.
000000******************************************************
000000*    01-SEQ-RTN t@Co
000000******************************************************
000000 01-SEQ-RTN.
000000     OPEN OUTPUT OUT-FILE.     
000000*    *** 
000000      MOVE 1 TO OUT-KY01.    
000000      MOVE 1 TO OUT-KY02.    
000000      MOVE "01234567" TO OUT-CD.    
000000      MOVE 1 TO OUT-OCC(1).    
000000      MOVE 2 TO OUT-OCC(2).    
000000      MOVE 3 TO OUT-OCC(3).    
000000      MOVE -123.45 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000      MOVE 2 TO OUT-KY01.    
000000      MOVE 2 TO OUT-KY02.    
000000      MOVE "89234567" TO OUT-CD.    
000000      MOVE 11 TO OUT-OCC(1).    
000000      MOVE 12 TO OUT-OCC(2).    
000000      MOVE 13 TO OUT-OCC(3).    
000000      MOVE +678.45 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000      MOVE 3 TO OUT-KY01.    
000000      MOVE 3 TO OUT-KY02.    
000000      MOVE "01654567" TO OUT-CD.    
000000      MOVE 21 TO OUT-OCC(1).    
000000      MOVE 22 TO OUT-OCC(2).    
000000      MOVE 23 TO OUT-OCC(3).    
000000      MOVE -321.54 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000      MOVE 4 TO OUT-KY01.    
000000      MOVE 4 TO OUT-KY02.    
000000      MOVE "01234087" TO OUT-CD.    
000000      MOVE 31 TO OUT-OCC(1).    
000000      MOVE 32 TO OUT-OCC(2).    
000000      MOVE 33 TO OUT-OCC(3).    
000000      MOVE +33333.44 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000      MOVE 5 TO OUT-KY01.    
000000      MOVE 5 TO OUT-KY02.    
000000      MOVE "00099944" TO OUT-CD.    
000000      MOVE 41 TO OUT-OCC(1).    
000000      MOVE 42 TO OUT-OCC(2).    
000000      MOVE 43 TO OUT-OCC(3).    
000000      MOVE -123.45 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000      MOVE 16 TO OUT-KY01.    
000000      MOVE 16 TO OUT-KY02.    
000000      MOVE "ABCDEFGH" TO OUT-CD.    
000000      MOVE 141 TO OUT-OCC(1).    
000000      MOVE 142 TO OUT-OCC(2).    
000000      MOVE 143 TO OUT-OCC(3).    
000000      MOVE -55555.88 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000      MOVE 17 TO OUT-KY01.    
000000      MOVE 1717 TO OUT-KY02.    
000000      MOVE "ABCabFGH" TO OUT-CD.    
000000      MOVE 241 TO OUT-OCC(1).    
000000      MOVE 242 TO OUT-OCC(2).    
000000      MOVE 243 TO OUT-OCC(3).    
000000      MOVE -77889.32 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000      MOVE 18 TO OUT-KY01.    
000000      MOVE 7896 TO OUT-KY02.    
000000      MOVE "aBCdEFGh" TO OUT-CD.    
000000      MOVE 341 TO OUT-OCC(1).    
000000      MOVE 342 TO OUT-OCC(2).    
000000      MOVE 343 TO OUT-OCC(3).    
000000      MOVE -0.09 TO OUT-SU. 
000000      WRITE OUT-REC.
000000*    ***    
000000     CLOSE OUT-FILE.  
000000 01-SEQ-RTN-END.
000000     EXIT.
000000******************************************************
000000*    02-SEQ-RTN t@C͂ƕ\
000000******************************************************
000000 02-SEQ-RTN.
000000     OPEN INPUT INP-FILE. 
000000*    ***    
000000     PERFORM UNTIL END-SW = 1
000000*...t@Cǂݍ
000000       READ INP-FILE           
000000         AT END 
000000           MOVE 1 TO END-SW    
000000         NOT AT END
000000           ADD 1 TO INP-CNT
000000           DISPLAY "-----------------"   
000000           DISPLAY "key " INP-KEY                                                            
000000           DISPLAY "cd  " INP-CD   
000000           DISPLAY "occur " INP-OCCUR   
000000           PERFORM TEST BEFORE
000000             VARYING IX FROM 1 BY 1 UNTIL IX > 3
000000             DISPLAY "INP-OCC(" IX ") " INP-OCC (IX) 
000000           END-PERFORM                  
000000***********DISPLAY "occ(3) " INP-OCC ( 3)   
000000           DISPLAY "su " INP-SU
000000           DISPLAY "INP-REC " INP-REC   
000000       END-READ                                                            
000000     END-PERFORM.
000000*    ***    
000000     CLOSE INP-FILE. 
000000*    ***    
000000     DISPLAY " W-VAL02( 2:5 )=" W-VAL02(2:5).
000000     DISPLAY " INPUT=" INP-CNT.
000000 02-SEQ-RTN-END.
000000     EXIT.
