#######################################################################
# Copyright (C) 2015 Jokanji
# 2015.09-11 Jokanji(m.ma)
# ʁE{pbP[W(W[)
#######################################################################
# C_B.pm (Ver 1.0)
#  Jokanji
#201x.xx.xx ...
#######################################################################
#-O
package C_B;
#######################################################################
use DBI;

require Exporter;
@ISA = ("Exporter");
@EXPORT = qw(Compare Console_ReadLine Inspect_tallying Inspect_replacing 
             _All_xxx _Low_Value _High_Value _Space _Zero _Numeric _Alphabetic
             Open Close StartI ReadS ReadI WriteS WriteI RewriteI DeleteI
             Connect UnConnect
            ); 
use strict 'vars';
use strict 'subs';

my (%Hopen,%Hhandle,%Hfetch,%Hnext_idx,%Hrow_ix,%Hcol_ix,%Hcolname,%Hnext_sql);
#-----------RDB----------------------
my ($RDB_Name,$dataSource,$Auto_Commit,$Idatabase,$Iuser,$Ipassword,$Idbh,$Isth);
my ($DB_Open,$Mybin,$Limit);

# f[^x[XIĉB
$RDB_Name="MySql";
##$RDB_Name="Oracle";
##$RDB_Name="SQL Server";

if ($RDB_Name eq "MySql"){
  $Iuser="root";  $Ipassword="PASSWD";
  $dataSource="DBI:mysql:DB";
  $Auto_Commit=1;
  $Mybin="binary"; #//MySQLe[uchar,varcharbinaryݒ肵ȂƂ -> 啶Aʂ邽
}
if ($RDB_Name eq "Oracle"){
  $Iuser="scott"; $Ipassword="tiger";
  $dataSource="DBI:Oracle:localhost/XE";
  $Auto_Commit=0;
}
if ($RDB_Name eq "SQL Server"){
  $Iuser="sa"; $Ipassword="PASSWD";
  $dataSource="DBI:ODBC:Driver={SQL Server};Server=HP-PC\\SQL_SV;Database=DB"; 
  $Auto_Commit=1;
}
#------------------------------------
$DBI::dbi_debug=9;        # DBĨfobNo̓x9ɐݒ肷
                          # ɂG[ɏڍׂȃbZ[W\܂
#------------------------------------
$Idbh="";
$Isth="";
#######################################################################
sub Compare
{
  my ($ls,$rs)=@_;

  my $lsw=$ls; my $rsw=$rs;
  my $li=length($ls); my $ri=length($rs);
  if ($li > $ri){ my $pad=' ' x ($li-$ri); $rsw=$rsw.$pad; }
  if ($li < $ri){ my $pad=' ' x ($ri-$li); $lsw=$lsw.$pad; }

  my $rt="";
  if    ($lsw eq $rsw){ $rt=0; } 
  elsif ($lsw gt $rsw){ $rt=1; }
  elsif ($lsw lt $rsw){ $rt=-1; }
  return $rt;
}
#######################################################################
sub Console_ReadLine
{
  my $str=""; my $c="";
  while ($c ne "\n"){ $c=getc; $str=$str.$c; }
  chomp $str;
  return $str;
}
#######################################################################
sub _All_xxx #//\Ӓ萔 ALL
{
  my ($s,$n)=@_;

  my $js="";
  for (my $i=0;$i<$n;$i++){
    $js.=$s;
  }
  $js=substr($js,0,$n); 
  return $js;
}
#######################################################################
sub _Low_Value #//\Ӓ萔 LOW_VALUE
{
  my ($n)=@_;

  my $rs=' ' x $n; #//0x20
  return $rs;
}
#######################################################################
sub _High_Value #//\Ӓ萔 HIGH_VALUE
{
  my ($n)=@_;

  my $rs='z' x $n; #//0x7A
  return $rs;
}
#######################################################################
sub _Space #//\Ӓ萔 SPACE
{
  my ($n)=@_;

  my $rs=' ' x $n;
  return $rs;
}
#######################################################################
sub _Zero #//\Ӓ萔 ZERO
{
  my ($n)=@_;

  my $rs='0' x $n;
  return $rs;
}
#######################################################################
sub _Numeric #//K(K)ɏCĉ
{
  my ($s)=@_;

  if ($s =~ /^[\+\-0-9\.]+$/){
    return 1;
  }else{
    return 0;
  }
}
#######################################################################
sub _Alphabetic #//K(K)ɏCĉ
{
  my ($s)=@_;

  if ($s =~ /^[a-zA-Z ]+$/){
    return 1;
  }else{
    return 0;
  }
}
#######################################################################
#//INSPECT TALLING
#//kb c:CHR a:ALL l:LEA before,after͂P̂݁IAɐw͂łȂ
#//******************************************************************//
sub Inspect_tallying
{
  my ($str,$r_cnt,$r_Chk,$alc,$alcs,$bef,$aft)=@_;

      my $Len=length($str); my $bei=-1; my $afi=-1;
      if ($bef ne ""){
         my $ln=length($bef); my $ok=0;
         for (my $i=0;$i<$Len;$i++)
         {
            $ok=0;
            for (my $j=0;$j<$ln;$j++){
              my $sr=substr($str,$i+$j,1); my $bf=substr($bef,$j,1);
              if ($i+$j < $Len && $sr eq $bf){ $ok=1; }
              else{ $ok=0; last; }
            }
            if ($ok==1){ $bei=$i; last; }
         }
      }

      if ($aft ne ""){
         my $ln=length($aft); my $ok=0;
         for (my $i=0;$i<$Len;$i++)
         {
            $ok=0;
            for (my $j=0;$j<$ln;$j++){
              my $sr=substr($str,$i+$j,1); my $at=substr($aft,$j,1);
              if ($i+$j < $Len && $sr eq $at){ $ok=1; }
              else{ $ok=0; last; }
            }
            if ($ok==1){ $afi=$i+$ln-1; last; }
         }
         if ($afi <0){
           print "Inspect_tallying AFTERw̕ȂI -> Ȃ ".$aft."\n"; return; #//AFTERw̕ȂƂI -> ȂIH
         }
      }

      if ($bei <0){ $bei=$Len; }

      my $kb=$alc; my $Spa=$alcs;

      if ($kb eq "a" || $kb eq "l") #//ALL,LEADING
      {
         my $ln=length($Spa); my $ok=0;
         for (my $i=0;$i<$Len;$i++)
         {
            if (!($i > $afi && $i < $bei)){ next; }

            $ok=0;
            for (my $j=0;$j<$ln;$j++){
               my $sr=substr($str,$i+$j,1); my $Sa=substr($Spa,$j,1);
               if ($i+$j < $Len && $sr eq $Sa && $$r_Chk[$i+$j]==0){ $ok=1; }
               else{ $ok=0; last; }
            }
            if ($kb eq "a" && $ok==0){ next; } #//ALL
            if ($kb eq "l" && $ok==0){ last; } #//LEADING

            #//vƂ
            $$r_cnt = $$r_cnt + 1; 
            for (my $j=0;$j<$ln;$j++){
               $$r_Chk[$i+$j]=1;
            }
            $i=$i+$ln-1;
         }
      }
      elsif ($kb eq "c") #//CHARACTERS
      { 
         for (my $i=0;$i<$Len;$i++)
         {
            if (!($i > $afi && $i < $bei)){ next; }
            if ($$r_Chk[$i]==1){ next; }
            $$r_cnt = $$r_cnt + 1;
            $$r_Chk[$i]=1;
         }
      } 

}
#######################################################################
#//INSPECT REPLACING
#//kb c:CHR a:ALL l:LEA f:FIRST before,after͂P̂݁IAɐw͂łȂ
#//uΏہAu͓A fs={"a","AB","CD"}
#//******************************************************************//
sub Inspect_replacing
{
  my ($r_Str,$r_Chk,$alc,$alcs,$bys,$bef,$aft)=@_;

      my $Len=length($$r_Str); my $bei=-1; my $afi=-1;
      if ($bef ne ""){
         my $ln=length($bef); my $ok=0;
         for(my $i=0;$i<$Len;$i++)
         {
            $ok=0;
            for (my $j=0;$j<$ln;$j++){
              my $Ip=substr($main::Insp_rep,$i+$j,1); my $bf=substr($bef,$j,1);
              if ($i+$j < $Len && $Ip eq $bf){ $ok=1; }
              else{ $ok=0; last; }
            }
            if ($ok==1){ $bei=$i; last; }
         }
      }
      if ($aft ne ""){
         my $ln=length($aft); my $ok=0;
         for (my $i=0;$i<$Len;$i++)
         {
            $ok=0;
            for (my $j=0;$j<$ln;$j++){
              my $Ip=substr($main::Insp_rep,$i+$j,1); my $at=substr($aft,$j,1); 
              if ($i+$j < $Len && $Ip eq $at){ $ok=1; }
              else{ $ok=0; last; }
            }
            if ($ok==1){ $afi=$i+$ln-1; last; }
         }
         if ($afi <0){
           print "Inspect_replacing AFTETw̕ȂI -> uȂ ".$aft."\n"; return; #//AFTETw̕ȂƂI -> ȂIH
         }
      }

      if ($bei <0){ $bei=$Len; }

      my $kb=$alc; my $Spa=$alcs; my $Spb=$bys;

      if ($kb eq "a" || $kb eq "l" || $kb eq "f") #//ALL,LEADING,FIRST
      {
         my $ln=length($Spb); my $ok=0;
         for (my $i=0;$i<$Len;$i++)
         {
            if (!($i > $afi && $i < $bei)){ next; }

            $ok=0;
            for (my $j=0;$j<$ln;$j++){
               my $Sr=substr($$r_Str,$i+$j,1); my $Sa=substr($Spa,$j,1);
               if ($i+$j < $Len && $Sr eq $Sa && $$r_Chk[$i]==0){ $ok=1; }
               else{ $ok=0; last; }
            }
            if (($kb eq "a" || $kb eq "f") && $ok==0){ next; }
            if ($kb eq "l" && $ok==0){ last; }

            #//vƂ
            substr($$r_Str,$i,$ln)=$Spb;
            for (my $j=0;$j<$ln;$j++){
               $$r_Chk[$i+$j]=1;
            }
            if ($kb eq "a" || $kb eq "l"){ $i=$i+$ln-1; }
            else{ last; } #//kb=="f"
         }
      }
      elsif ($kb eq "c") #//CHARACTERS
      {
         #//Spa=fs[f] ͓KɃZbg etc.."CHA"
         my $ln=length($Spb);
         if ($ln !=1){ print "Inspect_replacing ERR! CHAw͂P ".$Spb."\n"; exit; }
         for (my $i=0;$i<$Len;$i++)
         {
            if (!($i > $afi && $i < $bei)){ next; }

            if ($$r_Chk[$i]==1){ next; }

            substr($$r_Str,$i,$ln)=$Spb;
            $$r_Chk[$i]=1;
         }
      }

}
#######################################################################
sub Open
{
  my ($mode,$file,$g_file)=@_;

      if (!(exists $main::Hsele{$file})){ print "Open ERR! SELECT file ȂH ".$mode." ".$file."\n"; exit; }
      if (!(exists $main::Hsele2{$file})){ #//t@C 
         my ($fh,$ret);
         if ($mode eq "in"){ #//input
            $ret=open($fh,"$g_file");
            if ($ret){ $Hhandle{$file}=$fh; }else{ print "Open ERR! $mode,$file,$g_file\n"; exit; }
         }elsif ($mode eq "out"){ #//output
            $ret=open($fh,">$g_file");
            if ($ret){ $Hhandle{$file}=$fh; }else{ print "Open ERR! $mode,$file,$g_file\n"; exit; }
         }elsif ($mode eq "ext"){ #//extend
            $ret=open($fh,">>$g_file");
            if ($ret){ $Hhandle{$file}=$fh; }else{ print "Open ERR! $mode,$file,$g_file\n"; exit; }
         }elsif ($mode eq "io"){ #//i-o łȂ̂ŁAhmotsƂI -> ERROR!ƂI
            print "Open ERR! t@C h-nȂI ".$mode." ".$file."\n"; exit;
         }
      }else{ #//t@C
         #//g_file=>table 
         #//e[uZbg -> rŃe[u̕ύXȂŉBofňӁB
         $main::Hsele2{$file}.='|'.$g_file;
         $Hopen{$file}=$mode;
         $Hnext_idx{$file}=-1; $Hrow_ix{$file}=-1; $Hcol_ix{$file}="";
         if ($mode eq "out"){ #//output
            my $del="delete from $g_file";
            if (!(&Update($del))){ print "Open ERR! open output => delete table ".$mode." ".$g_file."\n";
               exit; 
            }
         }
      }

}
#######################################################################
sub Close
{
  my ($file)=@_;

      if (!(exists $main::Hsele2{$file})){ #//t@C 
         if (exists $Hhandle{$file}){
            my $fh=$Hhandle{$file};
            close $fh;
         }
      }else{ #-t@C

      }
}
#######################################################################
sub WriteS
{
  my ($file,$rec_name)=@_;

      my $obj=$main::Hval{$rec_name};
      my $rec=$obj->[9];

      if (!(exists $Hhandle{$file})){ print "WriteS ERR! t@C handle ȂH ".$file."\n"; exit; }
      my $fh=$Hhandle{$file};
      print $fh "$rec\n";

}
#######################################################################
sub ReadS
{
  my ($file)=@_;

      $main::_End=0;
      my $rec_name="";

      if (!(exists $Hhandle{$file})){ print "ReadS ERR! t@C handle ȂH ".$file."\n"; exit; }
      my $fh=$Hhandle{$file};

      my $sx=<$fh>; chomp $sx;                 #-READ XXX-FILE 
      if ($sx eq ""){ $main::_End=1; return; } #-AT END...
      
      if (!($main::Hsele{$file})){ print "ReadS ERR! SELECT FILE ɂȂH ".$file."\n"; exit; }
      my $sele=$main::Hsele{$file};
      if (index($sele,"|")<0){ $rec_name=$sele; }
      else{ #//}`R[h
         my @sp1 = split /\|/,$sele; $rec_name=$sp1[0];
      }

      #//R[hɃf[^Zbg
      $main::_SZ_ERR=0; if ($main::_RD==1){ $main::_RD=0; }

      if (!($main::Hdd{$rec_name})){ print "ReadS ERR! HddȂH $rec_name\n"; exit; }
      my @sp = split /\|/,$main::Hdd{$rec_name};
      my $keta = $sp[7];
      if (length($sx) == $keta){ #//ok
         #-ok
      }else{
         print "ReadS ERR! R[hႤIH $rec_name  [$keta] <-> [length($sx)]\n"; exit;
      }

      my $obj=$main::Hval{$rec_name};
      $obj->[9] = $sx;
      
}
#######################################################################
sub StartI
{
  my ($file,$cond,$key)=@_;

      my @sp1 = split /\|/,$main::Hsele2{$file};
      my $table=$sp1[1];
      my @sp = split /:/,$sp1[0];
      my $acce=$sp[0]; my $mkey=$sp[1]; my $mainkey=$sp[1]; #//main key
      if ($acce eq "r"){ #//ACCESS RANDOM
         print "StartI ERR! ACCESS RANDOMH ".$file."\n"; exit;
      }

      if (!($cond eq "=" || $cond eq ">=" || $cond eq ">")){ print "StartI ERR! rH ".$cond." ".$file."\n"; exit; }
      if ($key ne ""){ $mkey=$key; }
      my $val="";
      my $mkey2="main::$mkey";
      $val=$$mkey2;
      my $kbn=2; if ($cond eq "="){ $kbn=1; }
      my $sqtext=&rdb_sqtext($kbn,$table,$mainkey,$mkey,$cond,$val); 
      &Table_fetch($kbn,$file,$table,$sqtext);
      my $row=$Hrow_ix{$file};
      if ($row==0){ return 1; } #//start file invalid..

      if ($cond eq "="){
         $Hrow_ix{$file}=0;
         my $sqtext=&rdb_sqtext(2,$table,$mainkey,$mkey,">=",$val); 
         $Hnext_sql{$file}=$sqtext;
      }else{
         $Hnext_sql{$file}="";
      }
      $Hnext_idx{$file}=0;
      return 0;

}
#######################################################################
sub ReadI
{
  my ($file,$next,$key)=@_;

      $main::_Inv=0; $main::_End=0;

      my @sp1 = split /\|/,$main::Hsele2{$file};
      my $table=$sp1[1];
      my @sp = split /:/,$sp1[0];
      my $acce=$sp[0]; my $mkey=$sp[1]; my $mainkey=$sp[1]; #//main key
      if ($acce eq "r") #//ACCESS RANDOM
      {
        if ($next eq "next"){ print "ReadI ERR! ACCESS RANDOM -> NEXTH $file\n"; exit; }

        if ($key ne ""){ $mkey=$key; }
        my $mkey2="main::$mkey"; my $val=$$mkey2;
        my $sqtext=&rdb_sqtext(3,$table,$mainkey,$mkey,"=",$val); 
        &Table_fetch(3,$file,$table,$sqtext);
        my $row=$Hrow_ix{$file};
        if ($row==0){ $main::_Inv=1; return; } #//read file invalid..
        &fetch_data_set($file,0,$table,$mainkey);
        $Hnext_idx{$file}=0;
      }
      if ($acce eq "s") #//ACCESS SEQUENTIAL
      {
         if (!(exists $Hnext_idx{$file})){ $Hnext_idx{$file}=-1; }
         if (!(exists $Hrow_ix{$file})){ $Hrow_ix{$file}=-1; }
         my $nxt=$Hnext_idx{$file}; my $row=$Hrow_ix{$file};
         if ($row <0 || (!(exists $Hnext_sql{$file}))){ #//STARTȂ READ 
            my @spk = split /\|/,$main::Hdd{$mkey}; my $keta=$spk[7];
            my $mkey2="main::$mkey";
            $$mkey2=' ' x $keta; #//LOGH-VALUE ̑! -> space x 
            &StartI($file,">=","");
            $row=$Hrow_ix{$file};
            if ($row==0){ $main::_End=1; return; }
            $nxt=$Hnext_idx{$file};
         }
         my $sql=$Hnext_sql{$file};
         if ($sql ne ""){ #//READ(Fetch) Kv
            &Table_fetch(0,$file,$table,$sql);
            $nxt=$Hnext_idx{$file}; $row=$Hrow_ix{$file};
         }
         if ($row >0 && $row > $nxt){
            &fetch_data_set($file,$nxt,$table,$mainkey);
            $nxt++; $Hnext_idx{$file}=$nxt;
         }else{
            $main::_End=1; return; #//at end!
         }
      }
      if ($acce eq "d") #//ACCESS DYNAMIC
      {
         if ($next eq "next"){ #//seq.. read file next at end.. 
            if (!(exists $Hnext_idx{$file})){ $Hnext_idx{$file}=-1; }
            if (!(exists $Hrow_ix{$file})){ $Hrow_ix{$file}=-1; }
            my $nxt=$Hnext_idx{$file}; my $row=$Hrow_ix{$file};
            if ($row <0 || (!(exists $Hnext_sql{$file}))){ #//STARTȂ READ 
               my @spk = split /\|/,$main::Hdd{$mkey}; my $keta=$spk[7];
               my $mkey2="main::$mkey";
               $$mkey2=' ' x $keta; #//LOGH-VALUE ̑! -> space x 
               &StartI($file,">=","");
               $row=$Hrow_ix{$file};
               if ($row==0){ $main::_End=1; return; }
               $nxt=$Hnext_idx{$file};
            }
            my $sql=$Hnext_sql{$file};
            if ($sql ne ""){ #//READ(Fetch) Kv
               &Table_fetch(0,$file,$table,$sql);
               $nxt=$Hnext_idx{$file}; $row=$Hrow_ix{$file};
            }
            if ($row >0 && $row > $nxt){
               &fetch_data_set($file,$nxt,$table,$mainkey);
               $nxt++; $Hnext_idx{$file}=$nxt;
            }else{
               $main::_End=1; return; #//next at end!
            }
         }else{ #//random read file invalid..
           if ($key ne ""){ $mkey=$key; }
           my $mkey2="main::$mkey"; my $val=$$mkey2;
           my $sqtext=&rdb_sqtext(3,$table,$mainkey,$mkey,"=",$val); 
           &Table_fetch(3,$file,$table,$sqtext);
           my $row=$Hrow_ix{$file};
           if ($row==0){ $main::_Inv=1; return; } #//read file invalid..

           &fetch_data_set($file,0,$table,$mainkey);
           my $sqtext=&rdb_sqtext(4,$table,$mainkey,$mkey,"",$val); 
           $Hnext_sql{$file}=$sqtext;
           $Hnext_idx{$file}=0; $Hrow_ix{$file}=0;
         }
      }             
}
#######################################################################
sub WriteI
{
  my ($file,$rec_name)=@_;  #-($rec_name ͎gpȂ)

      my $mode=$Hopen{$file};
      if ($mode eq "in"){ print "WriteI ERR! OPEN INPUTH ".$file."\n"; exit; }

      my @sp1 = split /\|/,$main::Hsele2{$file};
      my $table=$sp1[1];
      my @sp = split /:/,$sp1[0];
      my $acce=$sp[0]; my $mkey=$sp[1]; ##my $mainkey=$sp[1]; #//main key
      my $name = "main::$mkey"; 
      my $valk=$$name;
      my $wbk="select $mkey from $table where $mkey = $Mybin \'$valk\'";
      my $rt=&rewrite_delete_fetch($wbk);
      if ($rt >0){ return 1; } #-WRITE INV

      if (!(exists $Hcolname{$file})){
         my $sqtext=&rdb_sqtext(9,$table,"","","",""); 
         &Table_fetch(9,$file,$table,$sqtext);
      } 
      my $po=$Hcolname{$file};

      my $ix=0; my $wjoin="";
      foreach my $name_s (@$po)
      {
         my $name = lc $name_s; #-KvȂAꉞ
         my $val="";
         $name = "main::$name"; 
         $val=$$name;
         if ($ix==0){ 
            my $ws="\'$val\'"; $wjoin.=$ws;
         }else{
            my $ws=",\'$val\'"; $wjoin.=$ws;
         }
          $ix++;
      }
      ##if ($ix != $Hcol_ix{$file}){ print "WriteI ERR! JH ix[$ix] col[$Hcol_ix{$file}]\n"; exit; }

      my $wb="insert into $table values($wjoin)";
      my $inv=0;
      if (&Update($wb)==0){ $inv=1; }else{ $inv=0; }
      return $inv;

}
#######################################################################
sub RewriteI
{
  my ($file,$rec_name)=@_;  #-($rec_name ͎gpȂ)

      my $mode=$Hopen{$file};
      if ($mode eq "in" || $mode eq "out"){ print "RewriteI ERR! OPEN INPUTH $file mode=$mode\n"; exit; }

      my @sp1 = split /\|/,$main::Hsele2{$file};
      my $table=$sp1[1];
      my @sp = split /:/,$sp1[0];
      my $acce=$sp[0]; my $mkey=$sp[1]; ##my $mainkey=$sp[1]; #//main key

      if (!(exists $Hcolname{$file})){
         my $sqtext=&rdb_sqtext(9,$table,"","","",""); 
         &Table_fetch(9,$file,$table,$sqtext);
      } 
      my $po=$Hcolname{$file};

      my $ix=0; my $wjoin=""; my $mkey_val="";
      foreach my $name_s (@$po)
      {
         my $name = lc $name_s; #-KvȂAꉞ
         my $val="";
         my $name2 = "main::$name"; 
         $val=$$name2;
         if ($name eq $mkey){ $mkey_val=$val; $ix++; next; }
         if ($wjoin eq ""){ 
            my $ws="$name=\'$val\'"; $wjoin=$ws;
         }else{
            my $ws=",$name=\'$val\'"; $wjoin.=$ws;
         }
         $ix++;
      }
      ##if ($ix != $Hcol_ix{$file}){ print "RewriteI ERR! JH ".$ix." ".$Hcol_ix{$file}."\n"; exit; }

      my $wb="select $mkey from $table where $mkey = $Mybin \'$mkey_val\'";
      my $rt=&rewrite_delete_fetch($wb);
      if ($rt==0){ return 1; }

      $wb="update $table set $wjoin where $mkey = $Mybin \'$mkey_val\'";
      my $inv=0;
      if (&Update($wb)==0){ $inv=1; }else{ $inv=0; }
      return $inv;

}
#######################################################################
sub DeleteI
{
  my ($file)=@_;

      my $mode=$Hopen{$file};
      if ($mode eq "in" || $mode eq "out"){ print "DeleteI ERR! OPEN INPUTH [$file] mode[$mode]\n"; exit; }

      my @sp1 = split /\|/,$main::Hsele2{$file};
      my $table=$sp1[1];
      my @sp = split /:/,$sp1[0];
      my $acce=$sp[0]; my $mkey=$sp[1]; ##my $mainkey=$sp[1]; #//main key

      my $val="";
      my $name = "main::$mkey"; 
      $val=$$name;

      my $wb="select $mkey from $table where $mkey = $Mybin \'$val\'";
      my $rt=&rewrite_delete_fetch($wb);
      if ($rt==0){ return 1; }

      $wb="delete from $table where $mkey = $Mybin \'$val\'";
      my $inv=0;
      if (&Update($wb)==0){ $inv=1; }else{ $inv=0; }
      return $inv;
}
#######################################################################
sub fetch_data_set
{
  my ($file,$nxt,$table,$mainkey)=@_;

  if ($nxt > 999999){ print "fetch_data_set ERR! fetch  >999999 !! EXIT!\n"; exit; }

      if (!(exists $Hcol_ix{$file}) || $Hcol_ix{$file} eq ""){ 
        my $sqtext=&rdb_sqtext(9,$table,"","","",""); 
        &Table_fetch(9,$file,$table,$sqtext);
      }
      my $col=$Hcol_ix{$file};

      my $row=$Hrow_ix{$file};
      if ($nxt >= $row){ print "fetch_data_set ERR! next=$nxt >= row=$rowH\n"; exit; }
      
      my $pvar=$Hcolname{$file};
      my $rc=sprintf("%s_%06d",$file,$nxt);
      my $pval=$Hfetch{$rc}; my $val=$pval->[0];

      my $sqtext="select * from $table where $mainkey = \'$val\'";

      #//SQLs
      $Isth=$Idbh->prepare($sqtext); if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "prepare ERROR\n"; exit; } 
      $Isth->execute();              if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "excute  ERROR\n"; exit; }

      my $rix=0;
      while (my $ref_row=$Isth->fetchrow_arrayref)
      {
        for (my $i=0;$i<$col;$i++){
           my $var=$pvar->[$i];
           my $val=$ref_row->[$i];
           $var="main::$var";
           $$var=$val;
        }
        $rix++;
      }
      $Isth->finish;
}
#######################################################################
sub rdb_sqtext
{
   my ($kbn,$table,$mainkey,$mkey,$cond,$val)=@_;

   my $sqtext="";

   if ($kbn==1){ #-start, '=' 
     if ($RDB_Name eq "MySql"){
       $sqtext="select $mainkey from $table where $mkey $cond $Mybin \'$val\' order by $mkey limit 1";
     }
     if ($RDB_Name eq "Oracle"){
       $sqtext="select $mainkey from $table where $mkey $cond $Mybin \'$val\' and ROWNUM <= 1 order by $mkey";
     }
     if ($RDB_Name eq "SQL Server"){
       $sqtext="select top 1 $mainkey from $table where $mkey $cond $Mybin \'$val\' order by $mkey";
     }
   } 
   if ($kbn==2){ #-start, '>=' 
     $sqtext="select $mainkey from $table where $mkey $cond $Mybin \'$val\' order by $mkey";
   } 
   if ($kbn==3){ #-read, '=' 
     $sqtext="select $mainkey from $table where $mkey $cond $Mybin \'$val\'";
   } 
   if ($kbn==4){ #-read inv -> read next p 
     my $mainval=$$mainkey;
     $sqtext="select $mainkey from $table where $mkey >= $Mybin \'$val\' and $mainkey <> $Mybin \'$mainval\' order by $mkey";
   } 

   if ($kbn==9){ #-col name 
     if ($RDB_Name eq "MySql"){
       $sqtext="select * from $table limit 1";
     }
     if ($RDB_Name eq "Oracle"){
       $sqtext="select * from $table where ROWNUM <= 1";
     }
     if ($RDB_Name eq "SQL Server"){
       $sqtext="select top 1 * from $table";
     }
   } 

   return $sqtext;
}
#######################################################################
sub Connect
{
   # f[^[x[Xɐڑ
   $Idbh=DBI->connect("$dataSource",$Iuser,$Ipassword,{ AutoCommit => $Auto_Commit }) or die $DBI::errstr;

   if ($RDB_Name eq "MySql"){
     my $set="set sql_mode='PAD_CHAR_TO_FULL_LENGTH'";
     &Update($set);
   }

   $DB_Open=1;
}
#######################################################################
sub UnConnect
{
   $Idbh->disconnect();
   $DB_Open=0;
}
#######################################################################
sub Table_fetch
{
  my ($kbn,$file,$table,$sqtext)=@_;

      if ($DB_Open==0){ print "caI[vĂ܂I\n"; exit; }

      #//SQLs
      $Isth=$Idbh->prepare($sqtext); if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "prepare ERROR\n"; exit; } 
      $Isth->execute();              if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "excute  ERROR\n"; exit; }

      if ($kbn==9){
        if (!(exists $Hcol_ix{$file})  || $Hcol_ix{$file} eq "") { $Hcol_ix{$file}=$Isth->{NUM_OF_FIELDS}; }
        if (!(exists $Hcolname{$file}) || $Hcolname{$file} eq ""){ $Hcolname{$file}=$Isth->{NAME_lc}; }
        return;
      }

      #//O FETCH NA
      my $rix=$Hrow_ix{$file};
      for (my $r=0; $r < $rix; $r++){
        my $rc=sprintf("%s_%06d",$file,$r);
        delete $Hfetch{$rc}; 
      }  

      #//e[uo
      $rix=0;
      while (my $ref_row=$Isth->fetchrow_arrayref)
      {
        if ($rix > 999999){ print "Table_fetch ERR! fetch  >999999 !! EXIT!\n"; exit; }
        my $rc=sprintf("%s_%06d",$file,$rix);
        $Hfetch{$rc}=[ @$ref_row ];
        $rix++;
      }
      $Isth->finish;

      $Hrow_ix{$file}=$rix;
      $Hnext_sql{$file}="";

}
#######################################################################
sub rewrite_delete_fetch
{
  my ($sqtext)=@_;

      if ($DB_Open==0){ print "caI[vĂ܂I\n"; exit; }

      #//SQLs
      $Isth=$Idbh->prepare($sqtext); if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "prepare ERROR\n"; exit; } 
      $Isth->execute();              if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "excute  ERROR\n"; exit; }

      #//e[uo
      my $rix=0;
      while (my @row=$Isth->fetchrow_array)
      {
        $rix++;
      }
      $Isth->finish;

      return $rix;
}
#######################################################################
sub Update
{
   my ($sqtext)=@_;

   $Isth=$Idbh->prepare($sqtext); if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "prepare ERROR\n"; exit; } 
   $Isth->execute();              if ($DBI::err){ &Rollback(); print "$sqtext\n"; print "excute  ERROR\n"; exit; }

   if ($Auto_Commit==0){
     &Commit(); 
   }
   return 1;
}
#######################################################################
sub Commit
{
   $Idbh->commit; 
}
#######################################################################
sub Rollback
{
   $Idbh->rollback;
}
#######################################################################
1;

